#include "Monocle.h"
#include "Graphics/SpriteAnimation.h"
#include "LevelEditor/LevelEditor.h"

using namespace Monocle;

namespace Dark
{
  class Player : public Entity
  {
  public:
    Player();
    void Update();

    Vector2 velocity;

    SpriteAnimation *sprite;
    AudioDeck *footsteps;

    int const FRICTION;
    float const MAXSPEED;
    int const ACCELERATION;    
  };

  class Creature : public Entity
  {
  public:
    Creature();
    void Update();

    Vector2 velocity;
    Vector2 direction;
    float aiTime;
    std::string state;

    SpriteAnimation *sprite;
    AudioDeck *skitter1;

    int const FRICTION;
    float const MAXSPEED;
    int const ACCELERATION;     
  };

  class DarkScene : public Scene
  {
  public:
    DarkScene();
    void Begin();
    void Update();

    LevelEditor *levelEditor;
  };

  class Text: public Entity
  {
  public:
    Text(const std::string& text, FontAsset* font=NULL);
    
    void Render();
    
    void SetFont(FontAsset* font) { this->font = font; }
    void SetText(const std::string& text) { this->text = text; }
    
  protected:
    FontAsset* font;
    std::string text;
  };
}

